// Copyright (c) 2024 Giorgos Vougioukas
//
// The license can be found in the LICENSE file.

#ifndef _MARKELLA_GOTO_WND_H_
#define _MARKELLA_GOTO_WND_H_

#include "definitions.h"

class MAR_GoToWnd
{
public:
  MAR_GoToWnd();
  ~MAR_GoToWnd();

  HWND Handle() const;

  static WDL_DLGRET GoToWndProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
private:
  void OnInitDialog(WPARAM wparam, LPARAM lparam);
  INT_PTR OnClose(WPARAM wparam, LPARAM lparam);
  void OnDestroy(WPARAM wparam, LPARAM lparam);
  void OnSysCommand(WPARAM wparam, LPARAM lparam);
  void OnCommand(WPARAM wparam, LPARAM lparam);
  WDL_DLGRET GoToWndLoop(UINT msg, WPARAM wparam, LPARAM lparam);

  HWND m_hwnd;
  HWND m_goto;
};

#endif // _MARKELLA_GOTO_WND_H_
